VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Prime"
   ClientHeight    =   2940
   ClientLeft      =   150
   ClientTop       =   720
   ClientWidth     =   4440
   Icon            =   "Prime.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   2940
   ScaleWidth      =   4440
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtOutputFile 
      Height          =   285
      Left            =   240
      TabIndex        =   8
      Text            =   "prime.txt"
      Top             =   1440
      Visible         =   0   'False
      Width           =   1815
   End
   Begin VB.CheckBox chkWriteToFile 
      Caption         =   "Write to file."
      Height          =   255
      Left            =   240
      TabIndex        =   7
      Top             =   1080
      Width           =   1815
   End
   Begin VB.CommandButton cmdStop 
      Caption         =   "Stop"
      Height          =   375
      Left            =   1320
      TabIndex        =   4
      Top             =   1920
      Width           =   855
   End
   Begin VB.TextBox txtHighLimit 
      Height          =   285
      Left            =   960
      TabIndex        =   3
      Top             =   600
      Width           =   1095
   End
   Begin VB.TextBox txtLowLimit 
      Height          =   285
      Left            =   960
      TabIndex        =   2
      Top             =   120
      Width           =   1095
   End
   Begin VB.ListBox lstPrimes 
      Height          =   2595
      Left            =   2280
      TabIndex        =   1
      Top             =   120
      Width           =   1935
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Start"
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Top             =   1920
      Width           =   855
   End
   Begin VB.Label Label4 
      Caption         =   "% Complete"
      Height          =   255
      Left            =   1080
      TabIndex        =   10
      Top             =   2520
      Width           =   975
   End
   Begin VB.Label lblPercentDone 
      Alignment       =   1  'Right Justify
      Height          =   255
      Left            =   360
      TabIndex        =   9
      Top             =   2520
      Width           =   615
   End
   Begin VB.Label Label2 
      Caption         =   "High Limit:"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   600
      Width           =   735
   End
   Begin VB.Label Label1 
      Caption         =   "Low Limit:"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   120
      Width           =   735
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuAbout 
         Caption         =   "&About"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
DefLng A-Z
Dim StopMath As Boolean

Private Sub chkWriteToFile_Click()

If chkWriteToFile.Value = 1 Then
    txtOutputFile.Visible = True
Else
    txtOutputFile.Visible = False
End If

End Sub

Private Sub cmdStart_Click()

StopMath = False
cmdStart.Enabled = False
cmdStop.Enabled = True
txtLowLimit.Enabled = False
txtHighLimit.Enabled = False
chkWriteToFile.Enabled = False
txtOutputFile.Enabled = False
Call CalculatePrimes

End Sub
Sub CalculatePrimes()

Dim PercentDone As Single, LastPercent As Single
L = Val(txtLowLimit)
If L = 0 Then L = 1
U = Val(txtHighLimit)
If U = 0 Then U = 1000

If L > 2147483647 Or U > 2147483647 Then
    MsgBox "Number out of range!!!", vbInformation, "Bad Number"
End
End If

If U <= L Then
     U = L + 1
End If

OutMode = chkWriteToFile.Value

If OutMode = 1 Then
    'Get Output filename
    OutFile$ = App.Path & "\" & txtOutputFile
    If UCase$(Dir(OutFile$)) = UCase$(txtOutputFile) Then
        Open OutFile$ For Append As #1
    Else
        Open OutFile$ For Output As #1
    End If
End If
Print

'This is here only to catch the number 2
If L = 1 Then
     If OutMode = 1 Then
          Print #1, LTrim$(Str$(L + 1))
     Else
          lstPrimes.AddItem X
          lstPrimes.ListIndex = lstPrimes.ListCount - 1
     End If
End If

'One is not prime by definition, two is already done.
If L = 1 Or L = 2 Then L = 3

'If start number is even, make it odd
'so only every other # is searched.
If L / 2 = Int(L / 2) Then
     L = L + 1
End If

X = L
'The following is stuff for the percent complete routine.
Pointer = 0
Total = U - L

Do

     'Skip any number ending in 5 except 5
     If X / 5 = Int(X / 5) And X > 5 Then
          X = X + 2
     End If

txtLowLimit = X
     'Assume the number is prime until proven otherwise
     Prime = 1
          For N = 2 To Int((X / 2) + 1)
               If X / N = Int(X / N) Then
                    'Not prime, move on to the next number.
                    Prime = 0
                    If StopMath = True Then
                    Close #1
                    Exit Sub
                    Exit For
                    End If
               End If
          DoEvents
          Next N

NextNumber:

'Print the number if it is a prime.
If Prime = 1 Then
     If OutMode = 1 Then
          Print #1, LTrim$(Str$(X))
     Else
     End If
        lstPrimes.AddItem X
        lstPrimes.ListIndex = lstPrimes.ListCount - 1
End If

     PercentDone = (Pointer * 100 / Total)
     lblPercentDone = Format$(PercentDone, "###.####")




If lstPrimes.ListCount > 32765 Then
    lstPrimes.RemoveItem (0)
End If


X = X + 2
Pointer = X - L
DoEvents
Loop While X <= U

Close

End Sub

Private Sub cmdStop_Click()

cmdStart.Enabled = True
cmdStop.Enabled = False
txtLowLimit.Enabled = True
txtHighLimit.Enabled = True
chkWriteToFile.Enabled = True
txtOutputFile.Enabled = True
StopMath = True

End Sub

Private Sub Form_Load()

txtLowLimit = "1"
txtHighLimit = "10000"
cmdStop.Enabled = False

End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)

StopMath = True
Close
End

End Sub

Private Sub mnuAbout_Click()

frmAbout.Show 1

End Sub

Private Sub mnuExit_Click()

StopMath = True
Close
End

End Sub
